!片持ち梁のねじり(CCX)
! 円柱(B32)、弾性体、等方性材料

implicit real*8(a-h,o-z)
dimension x(1000000),y(1000000),z(1000000),e66(6,6),b(3,3)&
&,mesh(30000000,8)
!プログラムはメートル、MPa
!寸法
d=13.d-3!直径(m)
!円形なら上のd、矩形なら下のb1,h
b1=1.d-3!幅(m)
h=3.d-3!高さ(m)
ell=3.0d0!長さ(m)
to=1.0d0!荷重 モーメント力(MN・m)
p=0.0d-6!荷重 先端の引張力(MN)
!z方向の分割数
nz=1000!軸方向
!1つあたりの要素の長さ
pi=asin(1.d0)*2.d0
zn=ell/nz!軸方向
!材料定数
young=206.d3!ヤング率(MN)
poi=0.3!ポアソン比
! 節点番号ごとの節点座標!i~mで始まるのがdoで使える 
nset=0
do k=0,nz*2
nset=nset+1
x(nset)=0.d0
y(nset)=0.d0
z(nset)=k*zn/2.d0
end do
nsettenzenbu=nset!全節点数
!接点番号と座標の出力
print'("*NODE, NSET=Nall")'
do i=1,nsettenzenbu
print'(i6,a,1pe17.9,a,1pe17.9,a,1pe17.9)',&
    &i,',',x(i),',',y(i),',',z(i)
end do
!要素番号とその要素の3接点の節点番号
nyou=0
do k=0,nz-1
nyou=nyou+1
mesh(nyou,1)=k*2+1
mesh(nyou,2)=mesh(nyou,1)+1
mesh(nyou,3)=mesh(nyou,2)+1
end do
!要素の出力
print'("*ELEMENT, TYPE=B32, ELSET=E1")'
do i=1,nyou
print'(i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6)',&
    &i,',',&
    &mesh(i,1),',',&
    &mesh(i,2),',',&
    &mesh(i,3)
end do
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!固定端の節点群を書きだす
print'("*NSET,NSET=kotei")'
print'("1")'
!載荷点の節点群を書きだす
print'("*NSET,NSET=saika")'
print'(i6)',nsettenzenbu
!梁中央の節点群を書きだす
print'("*NSET,NSET=tyuuou")'
print'(i6)',(nsettenzenbu+1)/2
!境界条件
print'("*BOUNDARY")'
print'("kotei,1,6")'
print'(A,a,i1,a,i1)','saika',',',1,',',2
print'(A,a,i1,a,i1)','saika',',',4,',',5
print'(A,a,i1)','tyuuou',',',1!梁中央
print'(A,a,i1)','tyuuou',',',4!梁中央
! 材料の設定
print'("*MATERIAL,NAME=EL1")'
print'("*ELASTIC")'
print'(f20.9,a,f10.6)',young,',',poi
!print'("*BEAM SECTION,ELSET=E1,MATERIAL=EL1,SECTION=RECT")'!矩形断面
!print'(f10.6,a,f10.6)',b1,',',h!矩形断面
print'("*BEAM SECTION,ELSET=E1,MATERIAL=EL1,SECTION=CIRC")'!円形断面
print'(f10.6,a,f10.6)',d,',',d!円形断面
print'(f10.6,a,f10.6,a,f10.6)',0.d0,',',1.d0,',',0.d0
! 載荷条件
!print'("*STEP,NLGEOM,INC=1000")'
print'("*STEP")'
print'("*STATIC,SOLVER=SPOOLES")'
!print'("0.1,1.")'
print'("*BUCKLE")'
print'("10,0.01")'
print'("*CLOAD")'
print'(A,a,i6,a,1pe13.5)','saika',',',6,',',to
print'(A,a,i6,a,1pe13.5)','saika',',',3,',',p
! datのオプション
print'("*NODE PRINT,NSET=Nall")'
print'("U")'
!print'("*EL PRINT,ELSET=E1")'
!print'("S")'
print'("*NODE FILE")'
print'("U")'
print'("*EL FILE")'
print'("S")'
print'("*END STEP")'
!
end

